'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MOUSE_RIGHT_BUTTON = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MOUSE_RIGHT_BUTTON = exports.MOUSE_RIGHT_BUTTON = 2;

var TrackingLink = function (_Component) {
  _inherits(TrackingLink, _Component);

  /* istanbul ignore next */
  function TrackingLink(props) {
    _classCallCheck(this, TrackingLink);

    var _this = _possibleConstructorReturn(this, (TrackingLink.__proto__ || Object.getPrototypeOf(TrackingLink)).call(this, props));

    _this.linkEl = null;

    _this.onClick = _this.onClick.bind(_this);
    _this.navigateToUrl = _this.navigateToUrl.bind(_this);
    _this.resolveByTimeout = _this.resolveByTimeout.bind(_this);
    _this.isMouseWheelClick = _this.isMouseWheelClick.bind(_this);
    _this.isChrome = _this.isChrome.bind(_this);
    _this.isSafari = _this.isSafari.bind(_this);
    _this.windowRef = null;
    return _this;
  }

  _createClass(TrackingLink, [{
    key: 'onClick',
    value: function onClick(event) {
      event.preventDefault();

      var nativeEvent = event.nativeEvent;

      // on Windows right click triggers touchTap event (react-tap-event-plugin bug)
      if (nativeEvent.button === MOUSE_RIGHT_BUTTON) {
        return false;
      }

      var _props = this.props,
          trackingFunction = _props.onClick,
          trackingTimeout = _props.trackingTimeout,
          targetBlank = _props.targetBlank;


      var isSafari = this.isSafari();

      if (targetBlank && isSafari) {
        // Safari blocks any window.open() calls made inside an async call.
        // the workaround is to create a ref to window.open() prior to the
        // async call and then set the window location/url when the promise resolves.
        this.windowRef = global.window.open();
      }

      // try to track the click but with the timeout
      // in case of tracking-blocking browser extensions or failure to load analytics scripts
      return Promise.race([trackingFunction(event), this.resolveByTimeout(trackingTimeout)]).then(this.navigateToUrl(nativeEvent));
    }
  }, {
    key: 'navigateToUrl',
    value: function navigateToUrl(event) {
      var _this2 = this;

      return function () {
        var _props2 = _this2.props,
            href = _props2.href,
            targetBlank = _props2.targetBlank,
            preventDefault = _props2.preventDefault;


        var ctrlKeyPressed = event.metaKey || event.ctrlKey;
        var mouseWheelClick = _this2.isMouseWheelClick(event);
        var isChrome = _this2.isChrome();

        // in chrome it's not possible to prevent opening a new tab on mouse wheel click
        // so we prevent opening url in the current tab and allow to open it in a new tab by Chrome
        // for other browsers we'll open in a new tab
        if (mouseWheelClick && isChrome) {
          return false;
        }

        if (!(href && !preventDefault)) return null;

        if (targetBlank || ctrlKeyPressed || mouseWheelClick && !isChrome) {
          // if this.windowRef is truthy we've detected Safari as the browser and
          // will use location.assign(href) to open a new tab.
          if (_this2.windowRef) {
            _this2.windowRef.location = href;
          } else {
            global.window.open(href, '_blank');
          }
        } else {
          // necessary to prevent blank page from loading
          if (_this2.windowRef) {
            _this2.windowRef.close();
          }

          global.location.href = href;
        }

        return true;
      };
    }
  }, {
    key: 'resolveByTimeout',
    value: function resolveByTimeout(timeout) {
      return new Promise(function (resolve) {
        global.setTimeout(resolve, timeout);
      });
    }
  }, {
    key: 'isMouseWheelClick',
    value: function isMouseWheelClick(event) {
      var mouseWheelClick = false;

      if (event.which && event.which === 2) {
        mouseWheelClick = true;
      } else if (event.button && event.button === 1) {
        mouseWheelClick = true;
      }

      return mouseWheelClick;
    }
  }, {
    key: 'isChrome',
    value: function isChrome() {
      return global.navigator.userAgent.indexOf('Chrome') > -1;
    }
  }, {
    key: 'isSafari',
    value: function isSafari() {
      return global.navigator.userAgent.indexOf('Safari') > -1;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props3 = this.props,
          children = _props3.children,
          href = _props3.href,
          addtionalClassName = _props3.className,
          trackingFunction = _props3.onClick,
          _props3$ariaLabel = _props3.ariaLabel,
          ariaLabel = _props3$ariaLabel === undefined ? '' : _props3$ariaLabel;


      var className = (0, _classnames2.default)('TrackingLink', _defineProperty({}, addtionalClassName, !!addtionalClassName));
      var onClick = trackingFunction ? this.onClick : undefined;

      return _react2.default.createElement(
        'a',
        {
          'aria-label': ariaLabel,
          className: className,
          href: href,
          onClick: onClick,
          ref: function ref(linkEl) {
            _this3.linkEl = linkEl;
          }
        },
        children
      );
    }
  }]);

  return TrackingLink;
}(_react.Component);

TrackingLink.propTypes = {
  ariaLabel: _propTypes2.default.string,
  children: _propTypes2.default.node.isRequired,
  href: _propTypes2.default.string.isRequired,
  className: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  targetBlank: _propTypes2.default.bool,
  preventDefault: _propTypes2.default.bool,
  trackingTimeout: _propTypes2.default.number
};
TrackingLink.defaultProps = {
  trackingTimeout: 500 // ms
};
exports.default = TrackingLink;